/***********************************************************************/
/*                                                                     */
/*                               Pio (C)                               */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2011-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Bruno Verlyck <Bruno.Verlyck@inria.fr>                             */
/*                                                                     */
/***********************************************************************/

void (*send_communication) (pio_buffer *ob, const COM_t *comm);

COM_t *send_values (pio_buffer *ob, TV_t **values, size_t nvals);
void send_one_value (pio_buffer *ob, TV_t *value);

#define send_t(TYPE, container) void send_##TYPE (pio_buffer *ob, container t);
send_t (string, struct string *)
send_t (chars, const char *)
send_t (int, int)
send_t (int_couple, struct cint *)
send_t (int_triple, struct tint *)
send_t (float, double)
send_t (float_couple, struct cfloat *)
send_t (float_triple, struct tfloat *)
send_t (string_vector, struct vector)
void send_chars_array (pio_buffer *ob, const char **s, size_t sz);
send_t (int_vector, struct vector)
send_t (int_couple_vector, struct vector)
send_t (int_triple_vector, struct vector)
send_t (float_couple_vector, struct vector)
send_t (float_triple_vector, struct vector)
send_t (float_vector, struct vector)
void send_c_float_matrix (pio_buffer *ob, double *m, size_t szi, size_t szj);
void send_fortran_float_matrix (pio_buffer *ob, double *m, size_t szi, size_t szj);
#undef send_t

extern COM_t *(*receive_communication) (pio_input_buffer *ib);

TV_t **receive_values (pio_input_buffer *ib);
TV_t *receive_one_value (pio_input_buffer *ib);

#define gen_receive(native, res_type) res_type receive_##native (pio_input_buffer *ib);
gen_receive (string, struct string)
const char *receive_chars(pio_input_buffer *ib);
gen_receive (int, int)
gen_receive (int_couple, struct cint)
gen_receive (int_triple, struct tint)
gen_receive (float, double)
gen_receive (float_couple, struct cfloat)
gen_receive (float_triple, struct tfloat)
gen_receive (string_vector, struct string *)
gen_receive (int_vector, int *)
gen_receive (int_couple_vector, struct cint *)
gen_receive (int_triple_vector, struct tint *)
gen_receive (float_vector, double *)
gen_receive (float_couple_vector, struct cfloat *)
gen_receive (float_triple_vector, struct tfloat *)
gen_receive (c_float_matrix, double *)
gen_receive (fortran_float_matrix, double *)
#undef gen_receive
